/*
 * Copyright 2016-2022 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license.
 */


package tests.annotations.onTypes.classLiteralWithExpectedType

import kotlin.reflect.KClass
import kotlin.test.assertEquals

@Target(AnnotationTarget.TYPE)
annotation class Anno(
    val k1: KClass<out CharSequence>,
    val k2: KClass<in String>,
    val ka: Array<KClass<out Number>>
)

fun f(): @Anno(String::class, CharSequence::class, [Double::class, Long::class, Int::class]) Unit {}

fun box(): String {
    assertEquals(
        "[@tests.annotations.onTypes.classLiteralWithExpectedType.Anno(k1=class java.lang.String, k2=interface java.lang.CharSequence, " +
                "ka=[class java.lang.Double, class java.lang.Long, class java.lang.Integer])]",
        ::f.returnType.annotations.toString()
    )

    return "OK"
}
